import { createRoute, OpenAPIHono, z } from "@hono/zod-openapi";
import { responses } from "../../../globalUtils/routeDefs/responses.js";
import { tryCatch } from "../../../globalUtils/tryCatch.js";
import { getINV } from "../controller/getinventory.js";
import { getCurrentCustomerInv } from "../controller/getCustomerInventory.js";
import { apiHit } from "../../../globalUtils/apiHits.js";

const app = new OpenAPIHono({ strict: false });
const Body = z.object({
    includeRunnningNumbers: z.string().openapi({ example: "x" }),
});
app.openapi(
    createRoute({
        tags: ["dataMart"],
        summary: "Returns All customer minus holds.",
        method: "get",
        path: "/getcustomerinventory",
        request: {
            body: {
                content: {
                    "application/json": { schema: Body },
                },
            },
        },
        responses: responses(),
    }),
    async (c) => {
        const customerData: any = c.req.queries();

        // make sure we have a vaid user being accessed thats really logged in
        apiHit(c, { endpoint: "/getcustomerinventory" });
        const { data, error } = await tryCatch(
            getCurrentCustomerInv(customerData ? customerData : null)
        );

        if (error) {
            return c.json(
                {
                    success: false,
                    message: "There was an error getting the inv.",
                    data: error,
                },
                400
            );
        }

        return c.json({
            success: data.success,
            message: data.message,
            data: data.data,
        });
    }
);
export default app;
